%global _description_python %{expand:
A python module which allows control of the General Purpose Input Outputs (GPIO).}
%global python_pigpio_version 1.78
%global debug_package %{nil}

Name:           pigpio
Version:        1.79
Release:        5%{?dist}
Summary:        C library for the Raspberry which allows control of the GPIO

ExclusiveArch:  aarch64 %{arm}

License:        Unlicense
URL:            https://github.com/joan2937/pigpio
VCS:            git+https://github.com/Leuca/pigpio#3751c5dff0f155be5c735537f0aa43886857a1e2:

BuildRequires:  gcc
BuildRequires:  python3-devel
%if 0%{?rhel} < 9
BuildRequires:  python2-devel
%endif
BuildRequires:  systemd-rpm-macros

Source:         pigpio-3751c5df.tar.gz

%if 0%{?rhel} < 9
%package -n     python2-pigpio
Summary:        Python 2 module for the Raspberry which allows control of the GPIO
Requires:       %{name}%{?_isa} = %{version}-%{release}
BuildArch:      noarch
%endif

%package -n     python3-pigpio
Summary:        Python 3 module for the Raspberry which allows control of the GPIO
Requires:       %{name}%{?_isa} = %{version}-%{release}
BuildArch:      noarch

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description
pigpio is a C library for the Raspberry which allows control of the General Purpose Input Outputs (GPIO).

%if 0%{?rhel} < 9
%description -n python2-pigpio %_description_python
%endif

%description -n python3-pigpio %_description_python

%description    devel
Development headers and shared libraries for %{name}

%prep
%setup -T -b 0 -q -n pigpio
%autopatch -p1

%build
export CFLAGS="%{optflags}"
%make_build

%install
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_libdir}
mkdir -p %{buildroot}%{_mandir}/man1
mkdir -p %{buildroot}%{_mandir}/man3
mkdir -p %{buildroot}%{_includedir}
mkdir -p %{buildroot}%{_unitdir}
%if 0%{?rhel} < 9
mkdir -p %{buildroot}%{python2_sitelib}
%endif
mkdir -p %{buildroot}%{python3_sitelib}
%make_install prefix=%{_prefix} libdir=%{_libdir} mandir=%{_mandir}
install -m 0644 pigpiod.service %{buildroot}%{_unitdir}

%files
%license UNLICENCE
%doc README
/opt/pigpio/cgi
%{_libdir}/libpigpio.so.1
%{_libdir}/libpigpiod_if.so.1
%{_libdir}/libpigpiod_if2.so.1
%{_bindir}/pig2vcd
%{_bindir}/pigpiod
%{_bindir}/pigs
%{_mandir}/man1/pig2vcd.1.gz
%{_mandir}/man1/pigpiod.1.gz
%{_mandir}/man1/pigs.1.gz
%{_mandir}/man3/pigpio.3.gz
%{_mandir}/man3/pigpiod_if2.3.gz
%{_mandir}/man3/pigpiod_if.3.gz
%{_unitdir}/pigpiod.service

%files devel
%{_libdir}/libpigpio.so
%{_libdir}/libpigpiod_if.so
%{_libdir}/libpigpiod_if2.so
%{_includedir}/pigpio.h
%{_includedir}/pigpiod_if.h
%{_includedir}/pigpiod_if2.h

%if 0%{?rhel} < 9
%files -n python2-pigpio
%license UNLICENCE
%{python2_sitelib}/pigpio-%{python_pigpio_version}-py%{python2_version}.egg-info
%{python2_sitelib}/pigpio.py
%{python2_sitelib}/pigpio.pyc
%{python2_sitelib}/pigpio.pyo
%endif

%files -n python3-pigpio
%license UNLICENCE
%{python3_sitelib}/pigpio-%{python_pigpio_version}-py%{python3_version}.egg-info
%pycached %{python3_sitelib}/pigpio.py

%post
%systemd_post pigpiod.service

%preun
%systemd_preun pigpiod.service

%postun
%systemd_postun_with_restart pigpiod.service

%changelog
* Tue Nov 07 2023 Luca Magrone <luca@magrone.cc> 1.79-5
- rpmspec: systemd: use env to set deamon arguments

* Sat Nov 05 2022 Luca Magrone <luca@magrone.cc> 1.79-4
- Change unit type from forking to simple

* Sat Nov 05 2022 Luca Magrone <luca@magrone.cc> 1.79-3
- Bump release
- spec: Build with optflags
- spec: Apply patches with autopatch
- spec: Add missing %%preun
- Fix spec indentation
- Fix shutdown systemd service
- use a rpkg macro to set version
- specfile: better compliance with guidelines
- fixed wrong branch
- added missing python2 file
- tell rpmbuild not to build debug stuff
- fixed wrong name of python egg-info files
- fixed typo where %% became $
- fixed python paths
- another attempt to build with man files
- create man subdirs
- change: create folders at the beguinning of %%install
- Another attempt to fix missing files during build
- attempt to fix file not found during build
- fixed install in unexistent dir
- attemp to fix missing man files
- install man files with explicit path
- fixed typo and paths
- fixed python description
- fixed python-packages
- use internet connection to determine version
- fixed missing systemd units dir
- attempt to fix version variable
- systems unit + fix version file path
- fixed missing python module description
- Create pull.yml
- fixed illegal character
- Create pigpio.template.spec
- Add updated DOC files.
- merge develop
- Bump version to 79
- Update README.md
- Fix detection of whether or not the system is a raspberry pi.
- Added "forth"  link to other languages section of index.html (main page).
- Added docker link to other languages section of index.html (main page).
- Auto generate MAN and HTML.
- Fix GPIO for BSC SPI in slave mode and update doc sources.
- added an example of using the pigpio library to implement the SENT interface.
SENT is an automotive standard single wire interface for robust communication
with sensors in a car, but the standard can be used anywhere.   It has error
detection including CRC checking.  There is a write up about it on the Blog:
https://surfncircuits.com/2020/11/27/implementing-a-single-edge-nibble-
transmission-sent-protocol-in-python-for-the-raspberry-pi-zero/
- bump develop branch version
- Fix issue#405 Prototype for gpioRunScript is duplicated.
- Fix issue#400 PI_CMD_EVT is unused in pigpiod_if2.c
- Fix issue#397 gpioSetTimerFunc NULL cancel error
- Fix Issue#402 Cannot handle multiple I2C devices on RPi 4B
- PR#415 fix simple type receieve -> receive
- PR#413 Update doc: return current PWM dutycycle instead of 0
- PR #404: Include stddef.h for size_t
- Reworked paulvee example and link.
- bit bang example code from paulvee
- Update README.md
- Merge pull request #387 from dawidowski/rework_pigpio_start_args
- Merge branch 'develop': Fix #375, fix #274, fix #373.
- Sync versions for next release (78).
- Modify pigpio_start arguments
- v7702 fixes 'Operation not permitted' and 'Delay on reboot/shutdown'.
- Merge pull request #342 from hazuki0x0/fix-initPeripherals
- Fix issue #274 - Delay on reboot/shutdown.
- Tidy file handling.
- Misc plus fix for #373
- New pulse per second example synced to wall time.
- Tidy file handling.
- Misc plus fix for #373
- New pulse per second example synced to wall time.
- Fixing possible fclose on null pointer
- Update docs
- Update index.html
- Update index.html
- Update docs
- Update index.html
- Update index.html
- Change version to 77.
- Revert "Remove excessive PROT_EXEC"
- Bump version and generate docs.
- Remove deprecated gpioCfgInternals API.  Fix issue #341.
- Fix issue #356, document wave_tx_at API is not supported on chained waves.
- Fix issue #355, python module event_callback documentation.
- Fix issue #353, initialising glitch filter
- Fix waveCBsOOLs tallys for 2d dma stride.
- Revert "Issue #220 Calling exit from a signal handler is not safe."
- fixed untracked files
- updated pigs.def for WVCAP and download.html for download version
- Issue #220 Calling exit from a signal handler is not safe.
- Remove excessive PROT_EXEC
- Revert "Remove excessive PROT_EXEC"
- Bump version and generate docs.
- Remove deprecated gpioCfgInternals API.  Fix issue #341.
- Fix issue #356, document wave_tx_at API is not supported on chained waves.
- Fix issue #355, python module event_callback documentation.
- Fix issue #353, initialising glitch filter
- Fix waveCBsOOLs tallys for 2d dma stride.
- Revert "Issue #220 Calling exit from a signal handler is not safe."
- fixed untracked files
- updated pigs.def for WVCAP and download.html for download version
- Issue #220 Calling exit from a signal handler is not safe.
- Bump rev to 7601.
- Remove excessive PROT_EXEC
- Fix DOC/MAN folder.
- Update .gitignore and remove cruft from DOC directory.
- Bump revision to v76.
- Fix doc generation warnings and other doc source corrections.
- Bump revision to 7600.
- Generate docs and make corrections.
- Merge branch 'wavesize' into develop
- Add test cases to x_* for padded waves.
- Remove excessive PROT_EXEC
- Added README to ensure DOC/MAN directory exists
- Added autogeneation of man pages and HTML for web site
- v75
- Change version to 7500 to sync with planned v75 release.
- Merge branch 'fix-cmake-setup-for-yocto' of https://github.com/myestro/pigpio
into myestro-fix-cmake-setup-for-yocto
- Merge branch 'master' of https://github.com/jaessy77/pigpio into
jaessy77-master
- Correct max wave resource comparison tests.
- Use two-beat DMA control block on pulse with set and clear OOLs.
- Fix error messages on gpioWaveCreatePad
- Allow creation of two waves with 50% padding using gpioWaveCreatePad.
- Added WaveCreatePad to pigpio.c
- Added wave_create_and_pad to pigpio.py
- Added WaveCreatePad to API
- Reverted size paramter fore wavecreate in x_pigpio.c
- Reverte added site paramezer in wave_create
- Added .so.* to gitignore
- Skip wave padding when size = 0
- Wave create using fixed size CB, OOL
- Code for BSC I2C/SPI slave on the BCM2711 (PI4B) Added documentation for
callback usage
- Corrected constant name in spiClose from PI_I2C_CLOSED to PI_SPI_CLOSED
- Bump to v74
- v7303 Fix waveform length when merging pulses (#223)
- v7302: Fix range of 'old' rev codes
- New hardware revision decode
- setsockopt() with properly initialized option argument. Fixes issue #298 and
possibly #274.
- Add 'develop' branch model process.
- Update pigpiod.service
- V73: I2C_SLOTS to 512 (from 64)
- V72+: new year
- Merge branch 'master' of https://github.com/flaviut/pigpio
- Create CONTRIBUTING.md (#1)
- Create SUPPORT.md (#2)
- Fix broken close handling
- V72
- V71+: rewrite chooseBestClock to fix errors
- V71+: #268 obey host name setting with env vars
- V71+: tidy up documentation overviews
- V71+: change the way DMA is reset to cater for edge case
- Moved option like option to actual option
- Forgot the command option
- Fixed path issue
- optimized python setup
- Python setup needs to be called from root
- Try to make things work
- Reenabled python isntall
- fixed usage of wrongly spelled target
- optimized cmake configuration
- V71+: #286 arm64 socket i/f response
- Fix network communication on arm64 - continued
- V71
- V70+: #282 close notification sockets when pigpiod "-m" option is used.
- Fix network communication on arm64
- Add support for RPi4 Model B running arm64 Linux
- Added option to build the libraries statically
- Merge branch 'master' of https://github.com/joan2937/pigpio
- V70
- V69+: BCM2711 PLLD 500->750 MHz Crystal 19.2->54M
- V69+: #258 reject and document illegal script commands
- V69+: #280 SPI/BSC SLAVE peripheral not available on BCM2711
- V69+: Change DBG_ALWAYS to DBG_USER for expected socket events
- Update README.md
- Update README.md
- V69
- V68+: #261 close gpio ISR fd when ISR cancelled.
- V68+: Changes for Pi4B (base address, default DMA channels, PUD)
- Fix some screwups in 64-bit patch where PRIX64 was used where PRIXPTR should
have been used.
- Use -pthread when linking shared libraries.
- Avoid installing shared libraries to man-page directories.
- Add support for raspberry pi detection on arm64.
- Fix compiler warnings on arm64.
- Add code to detect if the system is in fact a raspberry pi.
- Make "make uninstall" uninstall all man pages.
- Make DESTDIR option to make install and make uninstall actually work.
- Add soversion to shared libraries.
- V68
- Merge branch 'bennuttall-pi-repr' of https://github.com/bennuttall/pigpio into
bennuttall-bennuttall-pi-repr
- Merge branch 'keepalive' of https://github.com/guymcswain/pigpio into
guymcswain-keepalive
- Merge branch 'reportedLevels' of https://github.com/guymcswain/pigpio into
guymcswain-reportedLevels
- Merge branch 'master' of https://github.com/Noviv/pigpio into Noviv-master
- V67+: tided up I2C/SPI documentation
- Add repr to pi class
- enable SO_KEEPALIVE and SO_REUSEADDR on sockets
- Update reportedLevels prior to monitoring bits
- Added CMakeLists for shared libraries, executables, and (un)install
- V67: use with for Python locks, show_errors flag
- V67: #160 buffer size to 512, improved active test
- V67: #198 added process exit codes for pigs
- V67: #201 allow space for watchdog/event reports
- V66
- V66: #168 check commands against PI_CMD_SCRIPT
- V66: #133 fixed by simplifying timer loop
- V66: #178 update script parameters command PROCU
- V65
- wave delete comments
- Corrected test list argument errors
- Issues #131 and #141
- Docs plus reverse PR #164 flag meaning
- Merge branch 'issue-189' of https://github.com/maihde/pigpio into maihde-
issue-189
- Refine error handling approach
- Merge branch 'master' of https://github.com/damienstuart/pigpio into
damienstuart-master
- Merge branch 'master' of https://github.com/dbbnrl/pigpio into dbbnrl-master
- Merge branch 'patch-1' of https://github.com/jonas-schievink/pigpio into
jonas-schievink-patch-1
- Include for issue #188 and ignore various errors
- maintain backward compatibility with EMBEDDED_IN_VM
- Merge branch 'lib-signals' of https://github.com/MaitreDede/pigpio into
MaitreDede-lib-signals
- Merge branch 'master' of https://github.com/gyscos/pigpio into gyscos-master
- Changes by tateu
- Address #189 ensuring socket locks are released
- Ensure the lock is released if there is an exception on socket I/O.
- Allow 3-op script cmds to use regs as 3rd operand.
- cmake: include find_package_handle_standard_args
- Update README.md
- Replace conditionnal compilation symbol with internal configuration bit
- Added 'lib' target for Makefile
- Add systemd service file
- Fixing ifFlags check for additional flag
- Resolve merge conflict
- Merge branch 'master' of https://github.com/joan2937/pigpio
- Fixing command line arguments for new option -m
- V64
- V63
- Adding flag to disable alerts (polling of GPIOs)
- V62
- V61
- Add basic IPv6 support
- Fix URL.
- Reformat readme for better readability.
- Update README.md
- Update README.md
- Update README.md
- V60
- V59
- Expand setup.py setup data
- Add dist, *pyc and .egg-info to .gitignore
- Add pycache and build to .gitignore
- V58
- add option for running in foreground
- Add objects, libs, and executables to gitignore
- Add CROSS_PREFIX var to make cross-compilation easier
- Strip executables explicitly
- Remove redundancy in make vars
- V57
- V56
- Adding constants for spiFlags
- Fixed byte order in bbSPIXfer
- Changed default mode to 0
- Added (some) missing documentation
- Fixed delay for I2C and SPI
- Added Software SPI
- V55
- V54
- V53
- V52
- pep8:E711 comparison to None should be `if cond is not None:`
- pep8:E225 Whitespace around operators
- pep8:E261 At least two spaces before inline comment
- V51
- BugFix: a typo
- small bug fix for python example
- V50
- V49
- Merge pull request #54 from fudger/master
- Merge branch 'master' of https://github.com/fudger/pigpio.
- Define individual CMake variables for the different pigpio libraries.
- Fix copy-and-paste mistake.
- Add readme
- Add script that allows to start pigpiod as a service.
- Move CMake find script to util folder.
- Merge pull request #53 from fudger/master
- Changed title.
- Add CMake find script for pigpio.
- V48
- V47
- V46
- V45
- V44
- Introduced DISABLE_SER_CHECK_INITED
- V43
- Make installation paths configurable
- Add option to only bind to localhost
- Include version in help text to make identification easier.
- V42
- V41
- V40
- V39
- V38
- V37
- Option to invert bit bang serial.
- V36
- V35
- V34
- Merge branch 'Thuffir-master' Create shared libraries rather than static
- V33-a
- Shared libraries
- V33
- V32
- V32
- V32-a
- add EMBEDDED_IN_VM compilation flag to remove debugging and signal handling
- Update README.md
- V31
- V30
- V29
- Merge branch 'master' of https://github.com/joan2937/pigpio
- V28
- Python: add dht11 sensor python code.
- V27
- V26
- V25
- V24
- V23
- V23
- V23
- V23
- V23
- Merge branch 'master' of https://github.com/joan2937/pigpio
- V23
- Create Readme
- Create Readme
- Create Readme
- Create placeholder
- V23
- V22
- V21
- V21
- V21
- V20
- V19
- V18
- V17
- V16
- V15
- V14
- V13
- V12
- V11
- V10
- V9
- V8
- V7
- V6
